// SEASHELL_READONLY

#include <assert.h>
#include <limits.h>
#include <stdio.h>
#include "stack.h"
#include "cs136-trace.h"

// Accepted commands for the I/O-driver:
//   PUSH <int:VAL> Pushes VAL onto the top the stack.
//   POP Removes and prints the value from the top of the stack.
//   TOP Prints the value from the top of the stack.
//   EMPTY Prints a message indicating if the stack is empty or not.
int main(void) {
  const int cmd_push = lookup_symbol("PUSH");
  const int cmd_pop = lookup_symbol("POP");
  const int cmd_top = lookup_symbol("TOP");
  const int cmd_empty = lookup_symbol("EMPTY");
  
  struct stack *stck = stack_create();
  
  int cmd = INVALID_SYMBOL;
  while ((cmd = read_symbol()) != INVALID_SYMBOL) {
    if (cmd == cmd_push) {
      int val = INT_MIN;
      assert(scanf("%d", &val) == 1);
      stack_push(stck, val);
    } else if (cmd == cmd_pop) {
      int val = stack_pop(stck);
      printf("%d\n", val);
    } else if (cmd == cmd_top) {
      int val = stack_top(stck);
      printf("%d\n", val);
    } else if (cmd == cmd_empty) {
      bool empty = stack_empty(stck);
      printf("Stack is%sempty\n", (empty) ? " " : " not ");
    } else {
      assert(false);
    }
  }
  
  stack_destroy(stck);
}