// SEASHELL_READONLY

struct posn;

// posn_create(x, y) returns a new posn wiht x and y as x- and y-coordinates.
// effects: allocated memory (client must call posn_destroy).
// time:    O(1)
struct posn *posn_create(int x, int y);

// posn_destroy(posn) releases all resources used by posn.
// effects: invalidates posn
// time:    O(1)
void posn_destroy(struct posn *posn);

// posn_print(posn) prints posn to the console.
// effects: writes to console
// time:    O(1)
void posn_print(const struct posn *posn);
