#include <assert.h>
#include <stdbool.h>
#include <stdio.h>
#include <string.h>
#include "cs136-trace.h"
#include "patient.h"
#include "sequence.h"

// === patient <-> stack functions ============================================

// Your functions go here.

// === PATIENT CLIENT =========================================================

int client_patient(void) {
  const int cmd_len = lookup_symbol("LENGTH");
  const int cmd_at = lookup_symbol("AT");
  const int cmd_ins = lookup_symbol("INS");
  const int cmd_rem = lookup_symbol("REM");
  const int cmd_prnt = lookup_symbol("PRINT");
  const int cmd_sort = lookup_symbol("SORT");
    
  struct sequence *seq = sequence_create(pat_dest, pat_print, pat_comp);

  int cmd = INVALID_SYMBOL;
  while ((cmd = read_symbol()) != INVALID_SYMBOL) {
    if (cmd == cmd_len) {
      printf("Current sequence length is %d.\n", sequence_length(seq));
    } else if (cmd == cmd_at) {
      int idx = -1;
      assert(scanf("%d", &idx) == 1);
      // print the patient at index idx here
      printf("\n");
    } else if (cmd == cmd_ins) {
      int idx = -1;
      char name[100] = {'\0'};
      int prio = -1;
      assert(scanf("%d%s%d", &idx, name, &prio) == 3);
      struct patient *pat = patient_create(name, prio);
      sequence_insert_at(seq, idx, pat);
    } else if (cmd == cmd_rem) {
      int idx = -1;
      assert(scanf("%d", &idx) == 1);
      struct patient *pat = sequence_remove_at(seq, idx);
      // print the patient pat here
      printf("\n");
      pat_dest(pat);
    } else if (cmd == cmd_prnt) {
      sequence_print(seq);
    } else if (cmd == cmd_sort) {
      sequence_sort(seq);
    } else {
      assert(false);
    }
  }
  
  sequence_destroy(seq);
  return 0;
}