// SEASHELL_READONLY

#include <assert.h>
#include <stdio.h>
#include "queens.h"
#include "verify.h"
#include "cs136-trace.h"

int main(void) {
  const int cmd_create = lookup_symbol("CREATE");
  const int cmd_queen = lookup_symbol("QUEEN");
  const int cmd_solve = lookup_symbol("SOLVE");
  const int cmd_debug = lookup_symbol("DEBUG");

  struct board *brd = NULL;

  int dim = -1;
  int cmd = INVALID_SYMBOL;
  while ((cmd = read_symbol()) != INVALID_SYMBOL) {
    if (cmd == cmd_create) {
      if (brd != NULL) {
        board_destroy(brd);
      }
      assert(scanf("%d", &dim) == 1);
      brd = board_create(dim);
    } else if (cmd == cmd_queen) {
      assert(brd != NULL);
      int x = -1, y = -1;
      assert(scanf("%d%d", &x, &y) == 2);
      board_queen(brd, x, y);
    } else if (cmd == cmd_solve) {
      assert(brd != NULL);
      int count = -1;
      assert(scanf("%d", &count) == 1);
      printf("%solution found.\n", (board_solve(brd, count)) ? "S" : "No s");
      printf("Board with dimension %dx%d and %d queens:%sverified\n",
             dim, dim, count,
            (board_verify(board_get(brd), dim, count)) ? " " : " NOT ");
    } else if (cmd == cmd_debug) {
      assert(brd != NULL);
      board_debug(brd);
    } else {
      assert(false);
    }
  }

  if (brd != NULL) board_destroy(brd);
}